<?php

if(!defined('VALID_CMS_ADMIN')) { die('ACCESS DENIED'); }

    cmsCore::loadModel('inbus');
    $model = new cms_model_inbus(); 
 
    $id  = cmsCore::request('id', 'int');
    $opt = cmsCore::request('opt', 'str', 'config'); 

    cpAddPathway('Автобусы', '?view=components&do=config&id='.$id); 

    echo '<h3>Автобусы</h3>'; 

    $cfg = $inCore->loadComponentConfig('inbus');
    
    $file = 'http://bus.com.ua/?m=0';
    $html = file_get_contents($file);
    $doc = getHtml($html);
    $city_codes = getStationList($doc);
    
    if($opt=='saveconfig') { 

        $cfg['city_code']  = cmsCore::request('city_code', 'str');
        $cfg['update_period']  = cmsCore::request('update_period', 'str');
        $cfg['title_page']  = cmsCore::request('title_page', 'str');
        
        getDataFromSource(substr($cfg['city_code'], 0, -1));
        
        cmsCore::addSessionMessage($_LANG['AD_DO_SUCCESS'], 'success');
        
    }

$inCore->saveComponentConfig('inbus', $cfg);

function getDataFromSource($city_code)
{
    $inCore = cmsCore::getInstance(); 

	$cfg = $inCore->loadComponentConfig('inbus');

	$model = new cms_model_inbus(); 
            
    // schedule
            
    $data = $model->getData('schedule');
        
    $file = 'http://bus.com.ua/' . $city_code . '/time.html';
            
    // update in db
            
    $html = file_get_contents($file);
    $model->updateData('schedule', $html);

}

function getHtml($html) {

    $doc = new DOMDocument();
    libxml_use_internal_errors(true);
    $doc->loadHTML($html);
    libxml_clear_errors();

    return $doc;
    
}

function getStationList($doc) {
    
    $xpath = new DOMXpath($doc);

    $elements = $xpath->query('/html/body/table[3]/tr[2]/td[1]/table/tr[@class="aslist1" or @class="aslist2"]/td[6]');
    if (!is_null($elements)) {
        foreach ($elements as $element) {
            $nodes = $element->childNodes;
            foreach ($nodes as $node) {
                ($node->getAttribute('href')) ? $city_url = trim($node->getAttribute('href')) : '';
                preg_match('/(\d+)/', $city_url, $city_code);
                ($node->nodeValue) ? $city_name = trim($node->nodeValue) : '';
                $station_url[$city_code[1]][0] = $city_name;
                $station_url[$city_code[1]][1] = 'tablo_none';
            }
        }
    }
    
    $elements = $xpath->query('/html/body/table[3]/tr[2]/td[1]/table/tr[@class="aslist1" or @class="aslist2"]/td[3]/a');
    if (!is_null($elements)) {
        foreach ($elements as $element) {
            ($element->getAttribute('href')) ? $city_url = trim($element->getAttribute('href')) : '';
            preg_match('/(\d+)/', $city_url, $city_code);
            $nodes = $element->childNodes;
            foreach ($nodes as $node) {
                ($node->getAttribute('src')) ? $is_tablo = trim($node->getAttribute('src')) : '';
                
                if($is_tablo == '/images/tablo.ok.png')
                {
                    $station_url[$city_code[1]][1] = 'tablo_on';
                }
                else
                {
                    $station_url[$city_code[1]][1] = 'tablo_off';
                }
            }
        }
    }
    
    return $station_url;
}

?>

<form action="index.php?view=components&amp;do=config&amp;id=<?php echo $id;?>" method="post" name="optform" target="_self" id="city_form">
<input type="hidden" name="csrf_token" value="<?php echo cmsUser::getCsrfToken(); ?>" />
<div id="config_tabs" style="margin-top:12px;" class="uitabs">

    <ul id="tabs">
        <li><a href="#system"><span><?php echo $_LANG['SYSTEM_SETTINGS_TAB']; ?></span></a></li>
        <li><a href="#frontend"><span><?php echo $_LANG['FRONTEND_SETTINGS_TAB']; ?></span></a></li>
    </ul>

    <div id="system">

        <input name="opt" type="hidden" value="saveconfig" />
      
        <div><?php echo $_LANG['DESCR_CITY_CODE'];?></div>

        <select name="city_code">
            <?php foreach ($city_codes as $key => $value) {?>
            
                <?php switch($value[1]) {
                    case 'tablo_none':
                        $is_tablo = 'табло нет';
                        $attr_tablo = '-';
                        break;
                    case 'tablo_off':
                        $is_tablo = 'табло откл.';
                        $attr_tablo = '-';
                        break;
                    case 'tablo_on':
                        $is_tablo = 'табло есть';
                        $attr_tablo = '+';
                        break;
                    } ?>
            
                <?php if(substr($cfg['city_code'], 0, -1) == $key) { ?>
                    <option value="<?php echo $key . $attr_tablo; ?>" selected><?php echo iconv('cp1251', 'utf-8', iconv('utf-8', 'cp1252', $value[0])) . ' [' . $is_tablo . ']'; ?></option>
                <?php } else { ?>
                    <option value="<?php echo $key . $attr_tablo; ?>"><?php echo iconv('cp1251', 'utf-8', iconv('utf-8', 'cp1252', $value[0])) . ' [' . $is_tablo . ']'; ?></option>
                <?php } ?>

            <?php } ?>
        </select>
    
    </div>
    
    <div id="frontend">

        <div><?php echo $_LANG['TITLE_PAGE'];?></div>
        <input name="title_page" type="text" value="<?php if($cfg['title_page']){echo $cfg['title_page'];}else{echo $_LANG['NO_PROPERTY'];}?>" />
    
    </div>
  
    <hr />
  
    <div>
        <input name="save" type="submit" id="save" value="<?php echo $_LANG['SAVE'];?>" /> 
        <input name="back" type="button" id="back" value="<?php echo $_LANG['BACK'];?>" onclick="window.location.href='index.php?view=components';"/>
    </div>
    
    <div>
        <p align="center">inBus 1.0 free</p>
        <p align="center">Купите inBus 1.0 и получите доступ к онлайн-табло 213 автовокзалов Украины</p>
    </div>
    
</div>
</form>
