<?php  

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); } 

function inbus(){ 
 
	$inCore = cmsCore::getInstance(); 
	$inPage = cmsPage::getInstance(); 
	$inDB   = cmsDatabase::getInstance(); 
	$inUser = cmsUser::getInstance(); 
    $inConf = cmsConfig::getInstance();
 
	$model = new cms_model_inbus(); 

	global $_LANG; 
 
	$cfg = $inCore->loadComponentConfig('inbus');

	$pagetitle = $inCore->getComponentTitle(); 

	$inPage->addPathway($pagetitle, '/inbus');
	$inPage->setTitle($pagetitle);
	$inPage->setDescription($pagetitle);
    
    $template_dir = 'templates/' . $inConf->template . '/';
    $inbus_css = $template_dir . '/css/inbus.css';
    $inPage->addHeadCSS($inbus_css);
    $datatables_css = 'includes/jquery/datatables/css/jquery.dataTables.min.css';
    $inPage->addHeadCSS($datatables_css);
    $selectivity_css = 'includes/jquery/selectivity/css/selectivity-full.min.css';
    $inPage->addHeadCSS($selectivity_css);
    $tabs_theme_css = 'includes/jqueryui/tabs.mobile/css/jquery.mobile.tabs.theme.min.css';
    $inPage->addHeadCSS($tabs_theme_css);
    $font_awesome_css = '//maxcdn.bootstrapcdn.com/font-awesome/4.2.0/css/font-awesome.min.css';
    $inPage->addHeadCSS($font_awesome_css);
    
    $datatables_js = 'includes/jquery/datatables/js/jquery.dataTables.min.js';
    $inPage->addHeadJS($datatables_js);
    $selectivity_js = 'includes/jquery/selectivity/js/selectivity-full.min.js';
    $inPage->addHeadJS($selectivity_js);
    $init_js = 'components/inbus/js/init.js';
    $inPage->addHeadJS($init_js);
   
    $city_code = substr($cfg['city_code'], 0, -1);

    getDataFromSource($city_code);

    $data_schedule = getDataFromDb('schedule');

    $html_schedule = getHtml($data_schedule['data']);
    
    $schedule_table = parseSchedule($html_schedule);

	cmsPage::initTemplate('components', 'com_inbus_view')-> 
		assign('cfg', $cfg)->
        assign('schedule_table', $schedule_table)->
	display('com_inbus_view.tpl'); 

}

function getDataFromSource($city_code)
{
    $inCore = cmsCore::getInstance(); 

	$cfg = $inCore->loadComponentConfig('inbus');

	$model = new cms_model_inbus(); 

    $data = $model->getData('schedule');
        
    $time1 = strtotime($data['last_update']); // last update
    $time2 = strtotime(date('Y-m-d H:i:s')); // now
                
    $file = 'http://bus.com.ua/' . $city_code . '/time.html';
    
    if(round((abs($time2 - $time1) / 60), 2) > 604800)
    {
        // update in db
    
        $html = file_get_contents($file);
        $model->updateData($type, $html);
    
    }
}

function getDataFromDb($type) {

	$model = new cms_model_inbus(); 
    
    return $model->getData($type);
    
}

function getHtml($html) {

    $doc = new DOMDocument();
    libxml_use_internal_errors(true);
    $doc->loadHTML(base64_decode($html));
    libxml_clear_errors();

    return $doc;
    
}

function parseSchedule($doc) {

    $inCore = cmsCore::getInstance(); 
 
	$cfg = $inCore->loadComponentConfig('inbus');

    $xpath = new DOMXpath($doc);
    
    // schedule title
    
    $elements = $xpath->query('/html/body/div/index/table[1]/tr[1]/td[1]');

    if (!is_null($elements)) {
        foreach ($elements as $element) {
            $nodes = $element->childNodes;
            foreach ($nodes as $node) {
                ($node->nodeValue) ? $title_array[] = trim($node->nodeValue) : '';
            }
        }
    }

    $title = trim($title_array[0]);
    
    // time

    $elements = $xpath->query('/html/body/div/index/table[2]/tr[@align="left"]/td[1]');

    if (!is_null($elements)) {
        foreach ($elements as $element) {
            $nodes = $element->childNodes;
            foreach ($nodes as $node) {
                ($node->nodeValue) ? $time_array[] = trim($node->nodeValue) : '';
            }
        }
    }
    
    // route_from

    $elements = $xpath->query('/html/body/div/index/table[2]/tr/td[2]/a');

    if (!is_null($elements)) {
        foreach ($elements as $element) {
            $nodes = $element->childNodes;
            foreach ($nodes as $node) {
                ($node->nodeValue) ? $route_from_array[] = trim($node->nodeValue) : '';
            }
        }
    }
    
    // route_to

    $elements = $xpath->query('/html/body/div/index/table[2]/tr/td[3]/a');

    if (!is_null($elements)) {
        foreach ($elements as $element) {
            $nodes = $element->childNodes;
            foreach ($nodes as $node) {
                ($node->nodeValue) ? $route_to_array[] = trim($node->nodeValue) : '';
            }
        }
    }
    
    // transport

    $elements = $xpath->query('/html/body/div/index/table[2]/tr/td[5]/font');

    if (!is_null($elements)) {
        foreach ($elements as $element) {
            $nodes = $element->childNodes;
            foreach ($nodes as $node) {
                ($node->nodeValue) ? $transport_array[] = trim($node->nodeValue) : '';
            }
        }
    }
    
    // trust
    
    $elements = $xpath->query('/html/body/div/index/table[2]/tr/td[6]');

    if (!is_null($elements)) {
        foreach ($elements as $element) {
            $nodes = $element->childNodes;
            foreach ($nodes as $node) {
                ($node->nodeValue) ? $trust_array[] = trim($node->nodeValue) : '';
            }
        }
    }
   
    $bus_table .= '<table id="inbus_schedule" class="inbus_table" width=100%>';
    
    $bus_table .= '<thead><tr><th>Отправление</th><th><div id="schedule_show_filter_from" name="schedule_show_filter_from"></div></th><th><div id="schedule_show_filter_to" name="schedule_show_filter_to"></div><th>Транспорт</th><th>Надежность рейса</th></tr></thead>';
    $bus_table .= '<tbody>';
    
    for($i=0; $i<count($time_array); $i++)
    {
        $bus_table .= '<tr>
                  <td><b>' . $time_array[$i] . '</b></td>
                  <td class="schedule_row_route_from">' . $route_from_array[$i] . '</td>
                  <td class="schedule_row_route_to">' . $route_to_array[$i] . '</td>
                  <td>' . $transport_array[$i] . '</td>
                  <td>' . $trust_array[$i] . '</td>
                  </tr>';
    }

    $bus_table .= '</tbody></table>';
    
    return $bus_table;
    
}

?>