$.fn.dataTable.ext.errMode = 'none';

$(document).ready(function() {
    
    var inbus_table = $('#inbus_schedule').on( 'error.dt', function ( e, settings, techNote, message ) {
        console.log( 'An error has been reported by DataTables: ', message );
    } ).DataTable({
        'columnDefs': [
            { 'width': '10%', 'targets': 0 },
            { 'width': '20%', 'targets': 1 },
            { 'width': '20%', 'targets': 2 },
            { 'width': '20%', 'targets': 4 }
        ],
        'language': {
                        //'url': 'includes/jquery/datatables/js/Russian.json',
                        'emptyTable': 'Информация отсутствует',
                        'zeroRecords': 'Информация отсутствует'
                    },
        'ordering': false,
        'paging': false,
        'drawCallback': function (settings) {

            routeFrom = this.find('td.schedule_row_route_from').map(function() {
                return {
                    text: this.textContent
                };
            }).get();
            
            routeTo = this.find('td.schedule_row_route_to').map(function() {
                return {
                    text: this.textContent
                };
            }).get();
            
            routeFrom = groupBy(routeFrom, 'text');
            routeTo = groupBy(routeTo, 'text');

            $("#schedule_show_filter_from").selectivity({
                allowClear: true,
                items: routeFrom,
                placeholder: 'Рейс (откуда)',
                showSearchInputInDropdown: true,
            });
            
            $("#schedule_show_filter_to").selectivity({
                allowClear: true,
                items: routeTo,
                placeholder: 'Рейс (куда)',
                showSearchInputInDropdown: true,
            });
            
        }
    });

    $('#schedule_show_filter_from').on('change', function() {
        var searchCity = $('#schedule_show_filter_from').selectivity('value');
        if($('#schedule_show_filter_from ').selectivity('value') == null)
        {
            searchCity = '';
        }
        $('#inbus_schedule').DataTable().column(1).search(searchCity).draw();
    });
    
    $('#schedule_show_filter_to').on('change', function() {
        var searchCity = $('#schedule_show_filter_to').selectivity('value');
        if($('#schedule_show_filter_to').selectivity('value') == null)
        {
            searchCity = '';
        }
        $('#inbus_schedule').DataTable().column(2).search(searchCity).draw();
    });
    
} );

function groupBy(items,propertyName)
{
    var result = [];
    $.each(items, function(index, item) {
        if ($.inArray($.trim(item[propertyName]), result) == -1) {
            result.push($.trim(item[propertyName]));
        }
    });
    result = result.sort();
    return result;
}